-
Notifications
You must be signed in to change notification settings - Fork 1
Commit
This commit does not belong to any branch on this repository, and may belong to a fork outside of the repository.
- Loading branch information
1 parent
a4477e8
commit 3c9569a
Showing
4 changed files
with
132 additions
and
0 deletions.
There are no files selected for viewing
This file contains bidirectional Unicode text that may be interpreted or compiled differently than what appears below. To review, open the file in an editor that reveals hidden Unicode characters.
Learn more about bidirectional Unicode characters
Original file line number | Diff line number | Diff line change |
---|---|---|
@@ -0,0 +1,36 @@ | ||
#MEDIUM | ||
# 64 | ||
|
||
''' https://leetcode.com/problems/minimum-path-sum/ ''' | ||
|
||
# Given a m x n grid filled with non-negative numbers, find a path from top left to bottom right, which minimizes the sum of all numbers along its path. | ||
# Note: You can only move either down or right at any point in time. | ||
|
||
|
||
# Example 1: | ||
# Input: grid = [[1,3,1],[1,5,1],[4,2,1]] | ||
# Output: 7 | ||
|
||
# Explanation: Because the path 1 → 3 → 1 → 1 → 1 minimizes the sum. | ||
|
||
# Example 2: | ||
# Input: grid = [[1,2,3],[4,5,6]] | ||
# Output: 12 | ||
|
||
|
||
m=pow(2,31)-1 | ||
def minPathSum(self,grid): | ||
n=len(grid) | ||
m=len(grid[0]) | ||
d=[[1,0],[0,1]] | ||
dp=[[self.m for _ in range(0,m)] for _ in range(0,n)] | ||
dp[n-1][m-1]=grid[n-1][m-1] | ||
for i in range(n-1,-1,-1): | ||
for j in range(m-1,-1,-1): | ||
for dir in d: | ||
x=i+dir[0] | ||
y=j+dir[1] | ||
if(x<n and y<m ): | ||
dp[i][j]=min( dp[i][j],dp[x][y]+grid[i][j]) | ||
|
||
return dp[0][0] |
This file contains bidirectional Unicode text that may be interpreted or compiled differently than what appears below. To review, open the file in an editor that reveals hidden Unicode characters.
Learn more about bidirectional Unicode characters
Original file line number | Diff line number | Diff line change |
---|---|---|
@@ -0,0 +1,60 @@ | ||
#MEDIUM | ||
# 983 | ||
|
||
''' https://leetcode.com/problems/minimum-cost-for-tickets/description/ ''' | ||
|
||
|
||
# You have planned some train traveling one year in advance. The days of the year in which you will travel are given as an integer array days. Each day is an integer from 1 to 365. | ||
# Train tickets are sold in three different ways: | ||
# a 1-day pass is sold for costs[0] dollars, | ||
# a 7-day pass is sold for costs[1] dollars, and | ||
# a 30-day pass is sold for costs[2] dollars. | ||
# The passes allow that many days of consecutive travel. | ||
# For example, if we get a 7-day pass on day 2, then we can travel for 7 days: 2, 3, 4, 5, 6, 7, and 8. | ||
# Return the minimum number of dollars you need to travel every day in the given list of days. | ||
|
||
|
||
# Example 1: | ||
# Input: days = [1,4,6,7,8,20], costs = [2,7,15] | ||
# Output: 11 | ||
# ------------------------------------------------------------------- | ||
# Explanation: For example, here is one way to buy passes that lets you travel your travel plan: | ||
# On day 1, you bought a 1-day pass for costs[0] = $2, which covered day 1. | ||
# On day 3, you bought a 7-day pass for costs[1] = $7, which covered days 3, 4, ..., 9. | ||
# On day 20, you bought a 1-day pass for costs[0] = $2, which covered day 20. | ||
# In total, you spent $11 and covered all the days of your travel. | ||
|
||
# Example 2: | ||
# Input: days = [1,2,3,4,5,6,7,8,9,10,30,31], costs = [2,7,15] | ||
# Output: 17 | ||
# ------------------------------------------------------------------- | ||
# Explanation: For example, here is one way to buy passes that lets you travel your travel plan: | ||
# On day 1, you bought a 30-day pass for costs[2] = $15 which covered days 1, 2, ..., 30. | ||
# On day 31, you bought a 1-day pass for costs[0] = $2 which covered day 31. | ||
# In total, you spent $17 and covered all the days of your travel. | ||
|
||
|
||
|
||
from collections import defaultdict | ||
|
||
def mincostTickets(self,days,costs): | ||
self.dp=defaultdict(int) | ||
def f(days,ind): | ||
if(ind>=len(days)): | ||
return 0 | ||
elif(self.dp[ind]!=0): | ||
return self.dp[ind] | ||
nonlocal costs | ||
fin=pow(2,31) | ||
fin=min(fin,costs[0]+f(days,ind+1)) | ||
d,s=days[ind]+7,ind | ||
while(s<len(days) and days[s]<d): | ||
s+=1 | ||
fin=min(fin,costs[1]+f(days,s)) | ||
d,s=days[ind]+30,ind | ||
while(s<len(days) and days[s]<d): | ||
s+=1 | ||
fin=min(fin,costs[2]+f(days,s)) | ||
self.dp[ind]=fin | ||
return fin | ||
return f(days,0) |
This file contains bidirectional Unicode text that may be interpreted or compiled differently than what appears below. To review, open the file in an editor that reveals hidden Unicode characters.
Learn more about bidirectional Unicode characters
Original file line number | Diff line number | Diff line change |
---|---|---|
@@ -0,0 +1,36 @@ | ||
#MEDIUM | ||
# 64 | ||
|
||
''' https://leetcode.com/problems/minimum-path-sum/ ''' | ||
|
||
# Given a m x n grid filled with non-negative numbers, find a path from top left to bottom right, which minimizes the sum of all numbers along its path. | ||
# Note: You can only move either down or right at any point in time. | ||
|
||
|
||
# Example 1: | ||
# Input: grid = [[1,3,1],[1,5,1],[4,2,1]] | ||
# Output: 7 | ||
|
||
# Explanation: Because the path 1 → 3 → 1 → 1 → 1 minimizes the sum. | ||
|
||
# Example 2: | ||
# Input: grid = [[1,2,3],[4,5,6]] | ||
# Output: 12 | ||
|
||
|
||
m=pow(2,31)-1 | ||
def minPathSum(self,grid): | ||
n=len(grid) | ||
m=len(grid[0]) | ||
d=[[1,0],[0,1]] | ||
dp=[[self.m for _ in range(0,m)] for _ in range(0,n)] | ||
dp[n-1][m-1]=grid[n-1][m-1] | ||
for i in range(n-1,-1,-1): | ||
for j in range(m-1,-1,-1): | ||
for dir in d: | ||
x=i+dir[0] | ||
y=j+dir[1] | ||
if(x<n and y<m ): | ||
dp[i][j]=min( dp[i][j],dp[x][y]+grid[i][j]) | ||
|
||
return dp[0][0] |